/*
* $Log: icefear.c,v $
* Revision 1.6  2004/02/18 19:58:46  richq
* const fixes
*
* Revision 1.5  2004/02/14 16:42:44  richq
* Radnom number generator fixed. It was giving too many even values before.
*
* Revision 1.4  2004/01/27 20:19:13  richq
* The temp lord object has changed - it's now a pointer to the actual
* table entry and gets rid of the need for all the copying
* from temp to the table and back again.
*
* Revision 1.3  2004/01/25 21:17:27  richq
* Random numbers. Doomdark's captures effect Ice fear.
*
* Revision 1.2  2004/01/22 20:15:40  richq
* Bugfix? Icefear was calculated wrong
*
* Revision 1.1  2004/01/21 19:17:09  Default
* Code for calculating and defining Ice Fear.
*
*/

#include "icefear.h"

#include "stdlib.h"
#include "lords.h"
#include "location.h"
#include "doomdark.h"
#include "inter.h"


u16 icefear;
const location_t icefearHQ = {
  0x1a,0x05,0
};

int distance(const location_t * location1, const location_t * location2) {
  int dist = abs(location1->y - location2->y);
  dist += abs(location1->x - location2->x);
  return dist;
}

// based on code at e7fd
void calculate_icefear(location_t * location) {
  setSelectedLord(MORKIN);
  int ice = 0x7f;
  if (g_selectedLord->alive) {
    int dist = distance(&g_selectedLord->location, location);
    if (dist == 0) {
      // we are morkin, or with him. calculate morkins ice fear
      dist = distance(&icefearHQ, location);
      // this is the same as distance(&icefearHQ, &g_selectedLord->location);
      icefear = 0x1ff - dist*4;
      return;
    }
    else {
      // ice fear += distance of morkin from tower
      // i.e. the closer he is, the less pressure there is on everyone else
      ice = distance(&icefearHQ, &g_selectedLord->location);
    }
  } 
  icefear = ice;
  setSelectedLord(LUXOR);
  ice = 0x7f;
  if (g_selectedLord->alive) {
    // i.e ice fear gets stronger the further away from us Luxor is
    ice = distance(&g_selectedLord->location, location);
  }
  // ice fear gets stronger the more citadels doomdark takes
  icefear += ice + 0x30 + g_doomdarkCitadels; /* +doomdarks citadels;*/
  
}


u32 g_rseed;
int randomish(void) {
  if (!g_rseed) {
    g_rseed = game_frames&0xffff;
    g_rseed = (!g_rseed)?0x3d47:g_rseed;
  }
  
  unsigned char B = (g_rseed>>7)&0xff;
  unsigned char A = B + g_rseed;
  g_rseed = (A<<8) | B;
  return A;
}
