
/*
* $Log: location.h,v $
* Revision 1.3  2004/01/22 20:22:08  richq
* Saves location data. Useful when updating object locations, army tiles, etc
*
* Revision 1.2  2004/01/22 20:05:15  richq
* workOutLocationDetails - code to work out who and what is at a particular position.
*                         
* Revision 1.1  2004/01/21 19:19:11  Default   
* Everything to do with locations goes in here.
*                                              
*/

#ifndef _LOCATION_H
#define _LOCATION_H

#include "gba.h"
#include "features.h"

typedef struct Locdat {
   u8 x;        // ff13
   u8 y;        // ff14
   u8 terrain;  //   ff15
   u8 object;  //   ff16
   u8 area;   //<--   from 2nd table     ff17
   u8 domain;  //         -- " --         ff18
   u8 special;  //         -- " --         ff19
} locdat_t;

typedef struct {
  u8 x;
  u8 y;
  u8 direction;
} location_t;

extern const int positionModifier[][2];


// detailed information on a location. filled in workOutLocationDetails
extern locdat_t g_locdat;
// the square we are looking at
extern location_t lookAtPos;
// the square immediately infront of us
extern location_t g_inFront;    

// data must have its x, y vals filled!
void fillLocationData(locdat_t * data);
void saveLocationData(void);

void lookingAt(location_t * pos);
void workOutLocationDetails(location_t * pos);


#endif

