/*
* $Log: select.c,v $
* Revision 1.4  2004/01/31 15:35:47  Default
* Added the old-skool key value for selecting the lords.
*
* Revision 1.3  2004/01/27 20:19:13  richq
* The temp lord object has changed - it's now a pointer to the actual
* table entry and gets rid of the need for all the copying
* from temp to the table and back again.
*
* Revision 1.2  2004/01/25 21:27:52  richq
* list of allies for selection. Checks for "is ally" on previous/next.
*
* Revision 1.1  2004/01/22 22:26:01  richq
* Selection of lords. Incomplete at v1.1, but most of the display is there.
*
*
*/

#include "gfx.h"
#include "select.h"
#include "think.h"
#include "lords.h"
#include "look.h"
#include "savearea.h"
#include "tokens.h"
#include "tokendata.h"
#include "menu.h"


int g_hiliteSelect;

const char * keyboardContols = "cvbn1234567890qwertyuiopasdfghjk";
int g_selectableThings;
u8 g_selectableThingTable[32];
void createSelectableLordList(void) {
  int i;
  char control;
  g_selectableThings = 0;
  g_hiliteSelect = 0;
  for (i = 0; i < 32; i++) {
    setSelectedLord(i);
    if (g_selectedLord->moonring == 1) {
      // store the list of allies
      if (i == g_saveArea.selectedLord)
        g_hiliteSelect = g_selectableThings;
      g_selectableThingTable[g_selectableThings++] = i;
      
      
      // is an ally...
      control = ASCII_BOX_OK;
      // if night or tired, add a different token
      if (!g_selectedLord->time) {
        control = ASCII_BOX_NIGHT;
      } else
      if (!g_selectedLord->energy) {
        control = ASCII_BOX_TIRED;
      }
      // but if he's dead, it doesn't matter!
      if (!g_selectedLord->alive) {
        control = ASCII_BOX_DEAD;
      }
      addLiteralToken(control);
      
      /*  do not include the key?
          Leave it in as it helps recognise Lords better.
       */
      control = keyboardContols[i];
      if (control >= 'a') {
        //  uppercase
        control -= 0x20;
      }
      addLiteralToken(control);
      
      addNameToken(g_selectedLord->firstname);
      addNewlineToken();
      // print without changing position manually
      if (g_currentY != 0x12)
        print_tokens_pal(2);
      else
        print_tokens(2, 0x10, 0xF, 0x1e, 2);
    }
    
  }
  
}


void clearAndPressKeyText(void) {
  setupInfoScreen();
  addToTokenList(press2choose);
  print_tokens(0x0, 1, 0, 0x1e, 2);
}

// 607e
void select(void) {
  // fd76 clear display, do init text
  clearAndPressKeyText();
  createSelectableLordList();
  // now have a list both on screen and in mem of the selectable chars
  
  // originally, the player was forced to choose.. but here it 
  // works like any other screen.
  selectOption(g_hiliteSelect);
  
  g_lordScreen = SELECT_SCREEN;
}


void selectNextLord(void) {
  
  int lord = g_saveArea.selectedLord;
  while (lord < 31) {
    lord++;
    setSelectedLord(lord);
    if (g_selectedLord->moonring == 1) {
      g_saveArea.selectedLord = lord;
      clear_view();
      set_palette_time(g_selectedLord->time);
      look();
      break;
    }
  }
}
void selectPrevLord(void) {
  //g_saveArea.selectedLord--;
  int lord = g_saveArea.selectedLord;
  while (lord > 0) {
    lord--;
    setSelectedLord(lord);
    if (g_selectedLord->moonring == 1) {
      g_saveArea.selectedLord = lord;
      clear_view();
      set_palette_time(g_selectedLord->time);
      look();
      break;
    }
  }
  
}


void makeSelection(void){
  clearHighlighter();
//  gbaprintf("choose %d",g_selectableThingTable[g_hiliteSelect]);
  g_saveArea.selectedLord = g_selectableThingTable[g_hiliteSelect];
  look();
  
}

void selectDown(void){
  g_hiliteSelect++;
  if (g_hiliteSelect < g_selectableThings) {
    
    selectOption(g_hiliteSelect);
  } else {
    g_hiliteSelect--;
  }
  
}

void selectUp(void){
  if (g_hiliteSelect) {
    g_hiliteSelect--;
    selectOption(g_hiliteSelect);
  }
}

